package com.jenny.magic.mixins;

import com.jenny.magic.blocks.mana.ManaClient;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.resources.ResourceLocation;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(Gui.class)
public class ExperienceToMana {
    @Shadow
    protected int screenHeight;
    @Unique
    private float experienceProgress;
    @Unique
    private int experienceLevel;
    @Unique
    private ResourceLocation guiIconsLocation = new ResourceLocation("textures/gui/icons_mana.png");

    @Unique
    private Gui self() {
        return (Gui) (Object) this;
    }

    @Unique
    private boolean manaMode() {
        return System.currentTimeMillis() - ManaClient.lastUse < 1000;
    }


    /**
     * @author xJenny69
     * @reason display mana instead of xp bar
     */
    @Inject(method = "renderExperienceBar", at = @At("HEAD"))
    public void renderExperienceBarHead(GuiGraphics pGuiGraphics, int pX, CallbackInfo ci) {
        if (manaMode()) {
            experienceLevel = Minecraft.getInstance().player.experienceLevel;
            experienceProgress = Minecraft.getInstance().player.experienceProgress;

            Minecraft.getInstance().player.experienceLevel = ManaClient.mana;
            Minecraft.getInstance().player.experienceProgress = (float) ManaClient.mana / 100;
        }
    }

    @Inject(method = "renderExperienceBar", at = @At("TAIL"))
    public void renderExperienceBarTail(GuiGraphics pGuiGraphics, int pX, CallbackInfo ci) {
        if (manaMode()) {
            int l = this.screenHeight - 32 + 3;
            pGuiGraphics.blit(guiIconsLocation, pX, l, 0, 64, 182, 5);
            Minecraft.getInstance().player.experienceLevel = experienceLevel;
            Minecraft.getInstance().player.experienceProgress = experienceProgress;
        }
    }
}
